<!DOCTYPE html>
<html lang="ja">
<head>

    <?php
        // ページ設定
        $title = "デスクトップ環境について";
        $commonhtml = "${_SERVER['DOCUMENT_ROOT']}/buildmydist-2/commonhtml";
        $distro = "misc";

        // 共通ファイルを読み込み
        $domain = $_SERVER['HTTP_HOST'];
        include("${commonhtml}/head.php");
    ?>

</head>
<body>
    <?php include("${commonhtml}/beforemain.php"); ?>

    <main>
        <h2>デスクトップ環境とは</h2>
        <p>Linuxでは、Winwowsと違ってOS本体とGUIが完全に分離しています。そのため、OSを変更することなく全く違ったUIを使うことができます。</p>
        <p>Linuxの基本的な考え方は「モジュール化」です。1つのソフトには1つの仕事しかさせません。</p>
        <p>そうすることでユーザーは、例えば「タスクバーを表示するソフト」、「ウィンドウを管理するソフト」といったものを自由に選んで使うことができます。</p>
        <p>しかしそれらを1つ1つ選んで設定するのは初心者には大変で難解です。そのためそういったソフトをまとめて簡単に使いやすくしたものがあります。</p>
        <p>それが「デスクトップ環境」です。デスクトップ環境を変更するとランチャーやファイルマネージャー、ウィンドウマネージャーといったものがすべて入れ替わるため全く違った操作感になります。</p>
        <p>逆に言えば、ディストリビューションを変更しても（Arch LinuxからUbuntuに変えても）デスクトップ環境さえ一緒ならほぼ同じ操作感を実現することもできます。</p>
        <p>（これを利用して本来Ubuntuベースで開発されていたSerene Linuxはほぼ操作性を変更することなくFedora版やArch Linux版が開発されています。）</p>

        <h2>ここでは</h2>
        <p>このページでは主流のデスクトップ環境の名前と特徴、簡単な開発の経緯を紹介します。</p>
        <p>ひとことにデスクトップ環境といっても様々なものがあり、それぞれで目指しているものに違いがあります。</p>
        <p>いろんなデスクトップ環境を試して自分に一番あっているものを探してみてください。</p>

        <h2>技術的な細かい説明</h2>
        <p>GUIは「ディスプレイサーバ」で描写されます。Linuxでは現在、「Xorg」が主流です。最近では新しいものとして「Wayland」があるようです。個人的にはまだWaylandは不安定なので当分の間はXorgで良いと思っています。</p>
        <p>しかし、ディスプレイサーバはあくまで「GUIを描写する機能を提供」するだけなので、ディスプレイサーバだけではGUIは利用できません。そこでソフトをウィンドウにして表示できるようにするのが「ウィンドウマネージャ」です。ソフトの「最大化」「最小化」「閉じる」などのボタンとその機能を提供するのがウィンドウマネージャです。ウィンドウマネージャは様々な種類があり、「xfwm4」や「i3」「awesome」などが有名です。</p>
        <p>デスクトップ環境はあくまでツール群のため、掛け合わせることもできます。（依存関係などでできない場合もありますが）例えば、タイル型ウィンドウマネージャである「i3」とXfce関連を掛け合わせることもできます。（設定ファイルをいろいろ修正する必要がありますが）</p>

        <h2>デスクトップ環境の種類と特徴</h2>

        <h3>Gnome3</h3>
        <p>Linuxで最初に本格的に開発されたデスクトップ環境がGnomeです。</p>
        <p>GnomeはUbuntu 20.04にもデフォルトで採用されており、実績も多いことで有名です。</p>
        <p>Gnomeには主にGnome 2とGnome 3があり、この2つは全くの別物です。</p>
        <p>Gnome 3は現在の最新のGnomeです。JavaScriptをはじめとするウェブ技術で動作しており、独自の拡張機能を導入することができます。</p>
        <p>現在で最も使用されているデスクトップ環境で、拡張機能にも様々な種類があります。</p>
        <p>しかしその機能の豊富さから軽量ではないのが難点です。またディストリビューションを開発する場合にも難易度は高いデスクトップ環境です。</p>
        <p>次にGnome 2についてです。現在ではGnome 2の公式の開発は終了し、現在はMateという名前で開発が続いています。</p>
        <p>Gnome 2はGnome 3と違ってウェブ技術は使用されていません。</p>

        <h3>Mate</h3>
        <p>先程のGnome 2をベースに開発が続いているデスクトップ環境です。</p>

    </main>

    <?php include("${commonhtml}/aftermain.php"); ?>
</body>
</html>
